Create a Gauge in jQuery Using FusionCharts

Overview

FusionCharts is a JavaScript charting library that enables you to create interactive charts, gauges, maps and dashboards in JavaScript. We have built a simple and lightweight jQuery plugin which provides bindings for FusionCharts. The jquery-fusioncharts plugin allows you to easily add rich and interactive charts to any jQuery project.

In this page, we'll see how to install FusionCharts and render a gauge using the jquery-fusionCharts plugin.

Installation

Install FusionCharts and the jquery-fusioncharts plugin using any of the following methods:

To install FusionCharts and the jquery-fusioncharts plugin via npm follow the steps below:
Install the jquery-fusioncharts plugin

$ npm install jquery-fusioncharts --save

2. Install the fusioncharts package

$ npm install fusioncharts --save

To install the FusionCharts package and the jquery-fusioncharts component follow the steps below:
1. Include the jQuery core library.
2. Include the jquery-fusioncharts module.
3. Include the FusionCharts JavaScript files.
4. Include the FusionCharts theme file to apply style to the charts.

<head>
    <!-- jQuery -->
    <script type="text/javascript" src="https://code.jquery.com/jquery-3.3.1.min.js"></script>
    <!-- FusionCharts -->
    <script type="text/javascript" src="http://cdn.fusioncharts.com/fusioncharts/fusioncharts.js"></script>
    <!-- jQuery-FusionCharts -->
    <script type="text/javascript" src="https://rawgit.com/fusioncharts/fusioncharts-jquery-plugin/develop/dist/fusioncharts.jqueryplugin.min.js"></script>
    <!-- Fusion Theme -->
    <script type="text/javascript" src="http://cdn.fusioncharts.com/fusioncharts/themes/fusioncharts.theme.fusion.js"></script>
</head>

To install the FusionCharts package and the jquery-fusioncharts component follow the steps below:
1. Include the jQuery core library.
2. Include the jquery-fusioncharts module.
3. Include the FusionCharts JavaScript files which can be downloaded from here.
4. Include the FusionCharts theme file to apply style to the charts.

<head>
        <!-- jQuery -->
        <script type="text/javascript" src="path/to/local/jquery.min.js"></script>
        <!-- FusionCharts -->
        <script type="text/javascript" src="path/to/local/fusioncharts.js"></script>
        <!-- jQuery-FusionCharts -->
        <script type="text/javascript" src="path/to/local/jquery-fusioncharts.js"></script>
        <!-- Fusion Theme -->
        <script type="text/javascript" src="path/to/local/fusioncharts.theme.fusion.js"></script>
    </head>

That completes the installation of FusionCharts and the jquery-fusioncharts plugin.

Create your first gauge

Gauges are powerful tools that can showcase information using a radial scale to display data, and a dial to indicate the value. In this section, we will create an Angular Gauge.

To start with, we'll build a simple "Nordstorm Customer Satisfaction Index" gauge as shown below:

FusionCharts will load here..

The thresholds for his customer satisfaction score has been defined using the following range.

Range Color Hex Code
0-50 Red #F2726F
50-75 Yellow #FFC533
75-100 Green #62B58F

So, any score less than 50 is bad and is red. Any score between 50 and 75 is average and is yellow. Any score above 75 means good and is green.

Convert tabular data into JSON format

Now that you have the tabular data ready, it's time to convert it into JSON format, as FusionCharts accepts data in JSON or XML format. The converted format will look as shown below:

{
    // Chart Configuration
    "chart": {
        "caption": "Nordstorm's Customer Satisfaction Score for 2017",
        "lowerLimit": "0",
        "upperLimit": "100",
        "showValue": "1",
        "numberSuffix": "%",
        "theme": "fusion",
        "showToolTip": "0"
    },
    // Chart Data
    "colorRange": {
        "color": [{
            "minValue": "0",
            "maxValue": "50",
            "code": "#F2726F"
        }, {
            "minValue": "50",
            "maxValue": "75",
            "code": "#FFC533"
        }, {
            "minValue": "75",
            "maxValue": "100",
            "code": "#62B58F"
        }]
    },
    "dials": {
        "dial": [{
            "value": "81"
        }]
    }
}

In the above JSON:

  • Create the chart object to define the elements of the gauge.

  • Create the colorRange array to set the color associated with the specific range of values.

  • Specify minValue and maxValue within the color array under the colorRange array.

  • Specify the hex code of the color within the color array.

  • Create the dials object to represent the customer satisfaction score.

  • Create the dial object under dials object to set the value of the dial in an array.

Now that you have converted the tabular data to JSON format, let's see how to render the chart.

Render the Gauge

To render the gauge, follow the steps below:

  1. Include jQuery.

  2. Include jquery-fusioncharts plugin.

  3. Include fusioncharts core library.

  4. Include all gauges from Widgets.

  5. Include the FusionCharts theme file to apply the style to the gauge.

  6. Add the widgets and the theme as a dependency to the core.

  7. Store the chart configurations in a JSON object. In this JSON object:

    • Set the chart type as angulargauge. Each gauge type is represented with a unique gauge alias. For Angular gauge, the alias is angulargauge. Find the complete list of gauge types with their respective alias here.

    • Set the width and height (in pixels).

    • Set the dataFormat as JSON.

    • Embed the json data as the value of the dataSource.

  8. Add a container (instance) for the chart.

The consolidated code is given below:


var $ = require('jquery');
var FusionCharts = require('fusioncharts');
var jQueryFusionCharts = require('jquery-fusioncharts');
var Widgets = require('fusioncharts/fusioncharts.widgets');
var FusionTheme = require('fusioncharts/themes/fusioncharts.theme.fusion');
Widgets(FusionCharts);
FusionTheme(FusionCharts);
// Render the chart using insertFusionCharts method
$('document').ready(function () {

  $("#chart-container").insertFusionCharts({

    type: 'angulargauge', // Chart type
    renderAt: 'chart-container', // Container
    width: '450', // Width of the chart
    height: '250', // Height of the chart
    dataFormat: 'json', // Data Type
    dataSource: {
      // Chart Configuration
      "chart": {
        "caption": "Nordstorm's Customer Satisfaction Score for 2017",
        "lowerLimit": "0",
        "upperLimit": "100",
        "showValue": "1",
        "numberSuffix": "%",
        "theme": "fusion",
        "showToolTip": "0",
        "theme": "fusion"
      },
      // Chart Data
      "colorRange": {
        "color": [{
          "minValue": "0",
          "maxValue": "50",
          "code": "#F2726F"
        }, {
          "minValue": "50",
          "maxValue": "75",
          "code": "#FFC533"
        }, {
          "minValue": "75",
          "maxValue": "100",
          "code": "#62B58F"
        }]
      },
      "dials": {
        "dial": [{
          "value": "81"
        }]
      }
    }
  })
});


<html>
    <head>
        <!-- Include jQuery -->
        <script type="text/javascript" src=" https://code.jquery.com/jquery-3.3.1.min.js"></script>
        <!-- Include fusioncharts core library file -->
        <script type="text/javascript" src=" http://cdn.fusioncharts.com/fusioncharts/latest/fusioncharts.js"></script>
        <!-- Include fusion theme file -->
        <script type="text/javascript" src=" http://cdn.fusioncharts.com/fusioncharts/latest/themes/fusioncharts.theme.fusion.js"></script>
        <!-- Include fusioncharts jquery plugin -->
        <script type="text/javascript" src=" https://rawgit.com/fusioncharts/fusioncharts-jquery-plugin/develop/dist/fusioncharts.jqueryplugin.min.js"></script>
    </head>
    <body>
        <script type="text/javascript">
            $('document').ready(function () {
                $("#chart-container").insertFusionCharts({
                    type: "angulargauge",
                    width: "450",
                    height: "250",
                    dataFormat: "json",
                    dataSource: {
                        // Chart Configuration
                        "chart": {
                            "caption": "Nordstorm's Customer Satisfaction Score for 2017",
                            "lowerLimit": "0",
                            "upperLimit": "100",
                            "showValue": "1",
                            "numberSuffix": "%",
                            "theme": "fusion",
                            "showToolTip": "0"
                        },
                        // Chart Data
                        "colorRange": {
                            "color": [{
                                "minValue": "0",
                                "maxValue": "50",
                                "code": "#F2726F"
                            }, {
                                "minValue": "50",
                                "maxValue": "75",
                                "code": "#FFC533"
                            }, {
                                "minValue": "75",
                                "maxValue": "100",
                                "code": "#62B58F"
                            }]
                        },
                        "dials": {
                            "dial": [{
                                "value": "81"
                            }]
                        }
                    }
                });
            });
        </script>
        <div id="chart-container">FusionCharts will render here...</div>
    </body>
</html>


<html>
    <head>
        <!-- Include jQuery -->
        <script type="text/javascript" src="https://code.jquery.com/jquery-3.3.1.min.js"></script>
        <!-- Include fusioncharts core library file -->
        <script type="text/javascript" src="path/to/local/fusioncharts.js"></script>
        <!-- Include fusion theme file -->
        <script type="text/javascript" src="path/to/local/themes/fusioncharts.theme.fusion.js"></script>
        <!-- Include fusioncharts jquery plugin -->
        <script type="text/javascript" src="https://rawgit.com/fusioncharts/fusioncharts-jquery-plugin/develop/dist/fusioncharts.jqueryplugin.min.js"></script>
    </head>
    <body>
        <script type="text/javascript">
            $('document').ready(function () {
                $("#chart-container").insertFusionCharts({
                    type: "angulargauge",
                    width: "450",
                    height: "250",
                    dataFormat: "json",
                    dataSource: {
                        // Chart Configuration
                        "chart": {
                            "caption": "Nordstorm's Customer Satisfaction Score for 2017",
                            "lowerLimit": "0",
                            "upperLimit": "100",
                            "showValue": "1",
                            "numberSuffix": "%",
                            "theme": "fusion",
                            "showToolTip": "0"
                        },
                        // Chart Data
                        "colorRange": {
                            "color": [{
                                "minValue": "0",
                                "maxValue": "50",
                                "code": "#F2726F"
                            }, {
                                "minValue": "50",
                                "maxValue": "75",
                                "code": "#FFC533"
                            }, {
                                "minValue": "75",
                                "maxValue": "100",
                                "code": "#62B58F"
                            }]
                        },
                        "dials": {
                            "dial": [{
                                "value": "81"
                            }]
                        }
                    }
                });
            });
        </script>
        <div id="chart-container">FusionCharts will render here</div>
    </body>
</html>

That's it! Your first gauge using jquery-fusioncharts is ready.

Problem rendering the chart?

In case there is an error, and you are unable to see the chart, check for the following:

  • If you are getting a JavaScript error on your page, check your browser console for the exact error and fix accordingly. If you're unable to solve it, click here to get in touch with our support team.

  • If the chart does not show up at all, but there are no JavaScript errors, check if the FusionCharts Suite XT JavaScript library has loaded correctly. You can use developer tools within your browser to see if fusioncharts.js was loaded.

  • If you get a Loading Data or Error in loading data message, check whether your JSON data structure is correct, or there are conflicts related to quotation marks in your code.

Create a Gauge in SvelteJS Using FusionCharts

FusionCharts is a JavaScript charting library that lets you create interactive charts, gauges, maps, and dashboards using JavaScript. We have built a simple and lightweight SvelteJS directive, which provides bindings for FusionCharts.svelte-fusioncharts lets you add JavaScript charts in your Svelte application or project without any hassle.

In this page, you will see how to install FusionCharts and render a gauge using the svelte-fusioncharts directive.

Prerequisite

Before you begin, make sure your development environment includes Node.js and an npm package manager. SvelteJS requires Node.js version 10.9.0 or later. To download and install Node.js, please visit nodejs.org.

You need to have a Svelte project setup before proceeding any further. If not, you can follow the below steps to initiate the project.

Open a new terminal and execute the following command:

npx degit sveltejs/template my-first-svelte-project

This command creates a new project folder named my-first-svelte-project and downloads the svelte default project template into that folder. Before running the project we need to make sure that all needed development dependencies are being installed.

cd my-first-svelte-project
npm install

Open the terminal and enter npm run dev to serve your app on localhost:5000.

Installation and Including Dependencies

To install fusioncharts and the svelte-fusioncharts directive via npm follow the steps below.

Install svelte-fusioncharts and fusioncharts libraries with the following command:

npm install svelte-fusioncharts fusioncharts --save

After installing the FusionCharts components, you can replace the code in App.svelte file with the code shown in the steps below to create your first gauge. Import all the required dependencies to get started.

<script>
  //Import the Fusioncharts library
  import FusionCharts from "fusioncharts";

  //Import the Widgets
  import Widgets from "fusioncharts/fusioncharts.widgets";

  //Import the theme as fusion
  import FusionTheme from "fusioncharts/themes/fusioncharts.theme.fusion";

  //Import the Svelte component
  import SvelteFC, { fcRoot } from "svelte-fusioncharts";

  // Always set FusionCharts as the first parameter
  fcRoot(FusionCharts, Widgets, FusionTheme);
</script>

That completes the installation of FusionCharts and the svelte-fusioncharts directive.

Preparing the Data

Gauges are powerful tools that can showcase information using a radial scale to display data.

To start with, we'll build a simple angular gauge showcasing Nordstrom's Customer Satisfaction Score as shown below.

Gauge

The thresholds for the above sample is shown in the table below:

Range Color Hex Code
0-50 Red #F2726F
50-75 Yellow #FFC533
75-100 Green #62B58F

So, any score less than 50 is bad and is red. Any score between 50 and 75 is average and is yellow. Any score above 75 means good and is green.

FusionCharts accepts the data in JSON format. Prepare the above data in the following way

  • Create the colorRange object to set the color associated with the specific range of values.

  • Specify minValue and maxValue within the color array under the colorRange object.

  • Set the code attribute to specify the hex color of respective ranges.

  • Create the dials object to represent the customer satisfaction score.

  • Create the dial object under dials object to set the value of customer satisfaction score.

  • Include the json objects inside the <script> tag of the App.svelte file.

So the data in the tabular form will look as follows:

//STEP 2 : preparing the chart Data
const colorRange = {
  color: [
    {
      minValue: "0",      maxValue: "50",      code: "#F2726F"
    },    {
      minValue: "50,      maxValue: "75",      code: "#FFC533"
    }

     minValue: "75",  maxValue: "100",
  code: "#62B58F"    }
  ]
};

const dials = {
  dial: [
    {
      value: "81"
    javascript  ]
};

Configure Your Chart

ow that the data is ready, let's work on the styling, positioning and giving your gauge a context. Store the gauge configurations in a JSON object.

//STEP 3: Create your configuration object
const chartConfigs = {
  type: "angulargauge", // The gauge type
  width: "450", // Width of the gauge
  height: "250", // Height of the gauge
  dataFormat: "json", // Data type
  renderAt: "chart-container", //Container where the gauge will render
  dataSource: {
    // Gauge Configuration
    chart: {
      caption: "Nordstrom's Customer Satisfaction Score for 2017",
      lowerLimit: "0",
      upperLimit: "100",
      showValue: "1",
      numberSuffix: "%",
      theme: "fusion",
      showToolTip: "0"
    },
    // Chart Data
    colorRange: colorRange,
    dials: dials
  }
};

Find the complete list of chart types with their respective alias here.

Render the Chart

Finally, get ready to render your first gauge. Follow the steps mentioned below:

Step 1: In App.svelte include the necessary files and import the fusioncharts dependency.

Store the gauge configurations in a JSON object.

The consolidated code is shown below:

<script>
  import FusionCharts from 'fusioncharts';
  import Widgets from 'fusioncharts/fusioncharts.widgets';
  import FusionTheme from 'fusioncharts/themes/fusioncharts.theme.fusion';
  import SvelteFC, { fcRoot } from 'svelte-fusioncharts';

    // Always set FusionCharts as the first parameter
    fcRoot(FusionCharts, Widgets, FusionTheme);

    //STEP 2 : preparing the chart Data

    const colorRange = {
    "color": [{
      "minValue": "0",
      "maxValue": "50",
      "code": "#F2726F"
    }, {
      "minValue": "50",
      "maxValue": "75",
      "code": "#FFC533"
    }, {
      "minValue": "75",
      "maxValue": "100",
      "code": "#62B58F"
    }]
  };
  const dials = {
    "dial": [{
      "value": "81"
    }]
  };
  //STEP 3: Create your configuration object
  const chartConfigs = {
    type: 'angulargauge', // The gauge type
    width: '450', // Width of the gauge
    height: '250', // Height of the gauge
    dataFormat: 'json', // Data type
    renderAt:'chart-container', //Container where the gauge will render
    dataSource: {
      // Gauge Configuration
      "chart": {
        "caption": "Nordstrom's Customer Satisfaction Score for 2017",
        "lowerLimit": "0",
        "upperLimit": "100",
        "showValue": "1",
        "numberSuffix": "%",
        "theme": "fusion",
        "showToolTip": "0"
      },
      // Chart Data
      "colorRange": colorRange,
      "dials": dials
    }
  };
</script>

<SvelteFC {...chartConfigs} />

Step 2: Export the app from main.js.

import App from "./App.svelte";
var app = new App({
  target: document.body
});
export default app;

Step 3: Run npm run dev command in the terminal. Once the build is successful, open the localhost file to see your gauge.

See Your Chart

You should be able to see the gauge as shown below:

FusionCharts will load here..

If you are getting a JavaScript error on your page, check your browser console for the exact error and fix accordingly. If you're unable to solve it, click here to get in touch with our support team.

That's it! Your first gauge using svelte-fusioncharts is ready.

Create a Gauge in Vue Using FusionCharts

Overview

FusionCharts is a JavaScript charting library that enables you to create interactive charts, gauges, maps and dashboards in JavaScript. We have built a simple and lightweight Vue component which provides bindings for FusionCharts. The vue-fusioncharts component allows you to easily add rich and interactive charts to any Vue project.

In this page, we'll see how to install FusionCharts and render a gauge using the vue-fusionCharts component.

Installation

Install FusionCharts and the vue-fusioncharts component using any of the following methods:

To install FusionCharts and the vue-fusioncharts component via npm follow the steps below:
1. Install the vue-fusioncharts component

$ npm install vue-fusioncharts --save

2. Install fusioncharts package

$ npm install fusioncharts --save

To install the FusionCharts package and the vue-fusioncharts component follow the steps below:
1. Include Vuecore library.
2. Include the vue-fusioncharts component.
3. Include the FusionCharts JavaScript files which can be downloaded from here.
4. Include the FusionCharts theme file to apply style to the charts.

<head>
    <!-- Step 1 - Including vue  -->
    <script type="text/javascript" src="https://unpkg.com/[email protected]"></script>
    <!-- Step 2 - Including vue-fusioncharts component -->
    <script type="text/javascript" src="https://unpkg.com/vue-fusioncharts/dist/vue-fusioncharts.min.js"></script>
    <!-- Step 3 - Including the fusioncharts core library -->
    <script type="text/javascript" src="http://cdn.fusioncharts.com/fusioncharts/latest/fusioncharts.js"></script>
    <!-- Step 4 - Including the fusion theme -->
    <script type="text/javascript" src="http://cdn.fusioncharts.com/fusioncharts/latest/fusioncharts.theme.fusion.js"></script>
</head>

To install the FusionCharts package and the vue-fusioncharts component follow the steps below:
1. Include Vuecore library.
2. Include the vue-fusioncharts component.
3. Include the FusionCharts JavaScript files which can be downloaded from here.
4. Include the FusionCharts theme file to apply style to the charts.

<head>
    <!-- Step 1 - Including vue  -->
    <script type="text/javascript" src="path/to/local/vue.js"></script>
    <!-- Step 2 - Including vue-fusioncharts component -->
    <script type="text/javascript" src="path/to/local/vue-fusioncharts.js"></script>
    <!-- Step 3 - Including the fusioncharts core library -->
    <script type="text/javascript" src="path/to/local/fusioncharts.js"></script>
    <!-- Step 4 - Including the fusion theme -->
    <script type="text/javascript" src="path/to/local/themes/fusioncharts.theme.fusion.js"></script>
</head>

That completes the installation of FusionCharts and the vue-fusioncharts component.

Create your First Gauge

Gauges are powerful tools that can showcase information using a radial scale to display data.

To start with, we'll build a simple angular gauge showcasing Nordstorm's Customer Satisfaction Score as shown below.

The angular gauge is shown below:

FusionCharts will load here..

The thresholds for the above sample have been defined using the following range:

Range Color Hex Code
0-50 Red #F2726F
50-75 Yellow #FFC533
75-100 Green #62B58F

So, any score less than 50 is bad and is red. Any score between 50 and 75 is average and is yellow. Any score above 75 means good and are green.

Convert tabular data into JSON format

Now that you have the tabular data ready, it's time to convert it into JSON format, as FusionCharts accepts data in JSON or XML format. In this example, we will use the JSON format, as shown below:

{
    // Chart Configuration
    "chart": {
        "caption": "Nordstorm's Customer Satisfaction Score for 2017",
        "lowerLimit": "0",
        "upperLimit": "100",
        "showValue": "1",
        "numberSuffix": "%",
        "theme": "fusion",
        "showToolTip": "0"
    },
    // Chart Data
    "colorRange": {
        "color": [{
            "minValue": "0",
            "maxValue": "50",
            "code": "#F2726F"
        }, {
            "minValue": "50",
            "maxValue": "75",
            "code": "#FFC533"
        }, {
            "minValue": "75",
            "maxValue": "100",
            "code": "#62B58F"
        }]
    },
    "dials": {
        "dial": [{
            "value": "81"
        }]
    }
}

In the above JSON:

  • Create the chart object to define the elements of the gauge.

  • Create the colorRange array to set the color associated with the specific range of values.

  • Specify minValue and maxValue within the color array under the colorRange array.

  • Specify the hex code of the color within the color array.

  • Create the dials object to represent the customer satisfaction score.

  • Create the dial object under dials object to set the value of the dial in an array.

The chart object and the respective arrays contain a set of key-value pairs known as attributes. These attributes are used to set the functional and cosmetic properties of the gauge.

Now that you have converted the tabular data to JSON format, let's learn how to render the gauge.

Render the gauge

To render the gauge, open App.vue file and follow the steps below:

  1. Include the vue component.

  2. Include vue-fusioncharts component.

  3. Include fusioncharts core library.

  4. Include the chart type.

  5. Include the FusionCharts theme file to apply style to the charts.

  6. Register the vue-fusionCharts component.

  7. Store the chart configurations in a JSON object. In this JSON object:

    • Set the chart type as angulargauge. For Angular Gauge, the alias is angulargauge. Find the complete list of gauge types with their respective alias here.
    • Set the width and height (in pixels).
    • Set the dataFormat as JSON.
    • Embed the json data as the value of the dataSource.
<script>
import Vue from 'vue';
import VueFusionCharts from 'vue-fusioncharts';
import FusionCharts from 'fusioncharts';
import AngularGauge from 'fusioncharts/fusioncharts.widgets';
import FusionTheme from 'fusioncharts/themes/fusioncharts.theme.fusion';

Vue.use(VueFusionCharts, FusionCharts, AngularGauge, FusionTheme);
export default {
name: 'app',
    data () {
        return {
            "type": "angulargauge",
            "renderAt": "chart-container",
            "width": "550",
            "height": "350",
            "dataFormat": "json",
            "datasource": {
                "chart": {
                    "caption": "Nordstorm's Customer Satisfaction Score for 2017",
                    "lowerLimit": "0",
                    "upperLimit": "100",
                    "showValue": "1",
                    "numberSuffix": "%",
                    "theme": "fusion",
                    "showToolTip": "0"
                },
                // Chart Data
                "colorRange": {
                    "color": [{
                        "minValue": "0",
                        "maxValue": "50",
                        "code": "#F2726F"
                    }, {
                        "minValue": "50",
                        "maxValue": "75",
                        "code": "#FFC533"
                    }, {
                        "minValue": "75",
                        "maxValue": "100",
                        "code": "#62B58F"
                    }]
                },
                "dials": {
                    "dial": [{
                        "value": "81"
                    }]
                }
            }
        }
    }
}
</script>

<template>
    <div id="app">
        <div id="chart-container">
            <fusioncharts
            :type="type"
            :width="width"
            :height="height"
            :dataformat="dataformat"
            :datasource="datasource"
            >
            </fusioncharts>
        </div>
    </div>
</template>

<html>
<head>
    <!-- Including vue  -->
    <script type="text/javascript" src=" https://unpkg.com/[email protected]"></script>
    <!-- Including vue-fusioncharts component -->
    <script type="text/javascript" src=" https://unpkg.com/vue-fusioncharts/dist/vue-fusioncharts.min.js"></script>
    <!-- Including the fusioncharts core library -->
    <script type="text/javascript" src=" http://cdn.fusioncharts.com/fusioncharts/latest/fusioncharts.js"></script>
    <script type="text/javascript" src=" http://cdn.fusioncharts.com/fusioncharts/latest/fusioncharts.widgets.js"></script>
<!-- Including the fusion theme --> <script type="text/javascript" src=" http://cdn.fusioncharts.com/fusioncharts/latest/themes/fusioncharts.theme.fusion.js"></script> </head> <body> <div id="app"> <fusioncharts :type="type" :width="width" :height="height" :dataFormat="dataFormat" :dataSource="dataSource"></fusioncharts> </div> <script type="text/javascript"> // Use VueFusionCharts component by calling the Vue.use() method: Vue.use(VueFusionCharts, FusionCharts); var app = new Vue({ el: '#app', data: { width: '450', height: '250', type: 'angulargauge', dataFormat: 'json', dataSource: { // Chart Configuration "chart": { "caption": "Nordstorm's Customer Satisfaction Score for 2017", "lowerLimit": "0", "upperLimit": "100", "showValue": "1", "numberSuffix": "%", "theme": "fusion", "showToolTip": "0" }, // Chart Data "colorRange": { "color": [{ "minValue": "0", "maxValue": "50", "code": "#F2726F" }, { "minValue": "50", "maxValue": "75", "code": "#FFC533" }, { "minValue": "75", "maxValue": "100", "code": "#62B58F" }] }, "dials": { "dial": [{ "value": "81" }] } } } }); </script> </body> </html>
<html>
<head>
    <!-- Including vue  -->
    <script type="text/javascript" src="https://unpkg.com/[email protected]"></script>
    <!-- Including vue-fusioncharts component -->
    <script type="text/javascript" src="path/to/local/vue-fusioncharts.min.js"></script>
    <!-- Including the fusioncharts core library -->
    <script type="text/javascript" src="path/to/local/fusioncharts.js"></script>
    <script type="text/javascript" src="path/to/local/fusioncharts.widgets.js"></script>
<!-- Including the fusion theme --> <script type="text/javascript" src="path/to/local/themes/fusioncharts.theme.fusion.js"></script> </head> <body> <div id="app"> <fusioncharts :type="type" :width="width" :height="height" :dataFormat="dataFormat" :dataSource="dataSource"></fusioncharts> </div> <script type="text/javascript"> // Use VueFusionCharts component by calling the Vue.use() method: Vue.use(VueFusionCharts, FusionCharts); var app = new Vue({ el: '#app', data: { width: '450', height: '250', type: 'angulargauge', dataFormat: 'json', dataSource: { // Chart Configuration "chart": { "caption": "Nordstorm's Customer Satisfaction Score for 2017", "lowerLimit": "0", "upperLimit": "100", "showValue": "1", "numberSuffix": "%", "theme": "fusion", "showToolTip": "0" }, // Chart Data "colorRange": { "color": [{ "minValue": "0", "maxValue": "50", "code": "#F2726F" }, { "minValue": "50", "maxValue": "75", "code": "#FFC533" }, { "minValue": "75", "maxValue": "100", "code": "#62B58F" }] }, "dials": { "dial": [{ "value": "81" }] } } } }); </script> </body> </html>

That's it! Your first gauge using vue-fusioncharts is ready.

Problem rendering the chart?

In case there is an error, and you are unable to see the chart, check for the following:

  • If you are getting a JavaScript error on your page, check your browser console for the exact error and fix accordingly. If you're unable to solve it, click here to get in touch with our support team.

  • If the chart does not show up at all, but there are no JavaScript errors, check if the FusionCharts Suite XT JavaScript library has loaded correctly. You can use developer tools within your browser to see if fusioncharts.js was loaded.

  • If you get a Loading Data or Error in loading data message, check whether your JSON data structure is correct, or there are conflicts related to quotation marks in your code.

Create a Gauge in React using FusionCharts

Overview

FusionCharts is a JavaScript charting library that enables you to create interactive charts, gauges, maps and dashboards in JavaScript. We have built a simple and lightweight React component which provides bindings for FusionCharts. The react-fusioncharts component allows you to easily add rich and interactive charts to any React project.

In this page, we'll see how to install FusionCharts and render a gauge using the react-fusionCharts component.

Installation

Install FusionCharts and the react-fusioncharts component using any of the following methods:

To install fusioncharts and the react-fusioncharts component via npm follow the steps below:
1. Install the react-fusioncharts module

    $ npm install react-fusioncharts --save

2. Install the fusioncharts JS files

    $ npm install fusioncharts --save

To install the FusionCharts Suite and the react-fusioncharts component follow the steps below:
  1. Include the Reactcore library.
  2. Include Babelfor JSX transpiling.
  3. Include the FusionCharts JavaScript files from CDN.
  4. Include the react-fusioncharts module.
  5. Include the theme file.
The consolidated code is shown below:

<head>
    <!-- Step 1 - Including react -->
    <script type="text/javascript" src="https://unpkg.com/react@16/umd/react.development.js"></script>
    <script type="text/javascript" src="https://unpkg.com/react-dom@16/umd/react-dom.development.js"></script>
    <!-- Step 2 - Including Babel for JSX transpiling -->
    <script type="text/javascript" src="https://unpkg.com/babel-standalone@6/babel.min.js"></script>
    <!-- Step 3 - Including the fusioncharts core library -->
    <script type="text/javascript" src="http://cdn.fusioncharts.com/fusioncharts/latest/fusioncharts.js"></script>
    <!-- Step 4 - Including the react-fusioncharts component-->
    <script type="text/javascript" src="https://unpkg.com/[email protected]/dist/react-fusioncharts.min.js"></script>
    <!-- Step 5 - Including the fusion theme -->
    <script type="text/javascript" src="http://cdn.fusioncharts.com/fusioncharts/latest/fusioncharts.theme.fusion.js"></script>
</head>

To install the FusionCharts Suite and the react-fusioncharts component follow the steps below:
  1. Include the Reactcore library.
  2. Include Babelfor JSX transpiling.
  3. Include the FusionCharts JavaScript files, which can be downloaded from here.
  4. Include the react-fusioncharts component.
  5. Include the FusionCharts theme file to apply style to the charts.
The consolidated code is shown below:

<head>
    <!-- Step 1 - Including react  -->
    <script type="text/javascript" src="path/to/local/react.js"></script>
    <script type="text/javascript" src="path/to/local/react-dom.js"></script>
    <!-- Step 2 - Including Babel for JSX transpiling -->
    <script type="text/javascript" src="path/to/local/babel-core.js"></script>
    <!-- Step 3 - Including the fusioncharts core library -->
    <script type="text/javascript" src="path/to/local/fusioncharts.js"></script>
    <!-- Step 4 - Including the react-fusioncharts component -->
    <script type="text/javascript" src="path/to/local/react-fusioncharts.js"></script>
    <!-- Step 5 - Including the fusion theme -->
    <script type="text/javascript" src="path/to/local/themes/fusioncharts.theme.fusion.js"></script>
</head>

Create your first gauge

Gauges are powerful tools that can showcase information using a radial or linear scale to display data.

To start with, we'll build a simple angular gauge showcasing Nordstorm's Customer Satisfaction Score as shown below.

FusionCharts Suite has 95+ chart types for you to explore. Find the complete list of chart types here.

The angular gauge is shown below:

FusionCharts will load here..

The thresholds for the above sample have been defined using the following range:

Range Color Hex Code
0-50 Red #F2726F
50-75 Yellow #FFC533
75-100 Green #62B58F

So, any score less than 50 is bad and is red. Any score between 50 and 75 is average and is yellow. Any score above 75 means good and are green.

Convert tabular data into JSON format

Now that you have the tabular data ready, it's time to convert it into JSON format, as FusionCharts accepts data in JSON or XML format. In this example, we will use the JSON format, as shown below:

{
    // Chart Configuration
    "chart": {
        "caption": "Nordstorm's Customer Satisfaction Score for 2017",
        "lowerLimit": "0",
        "upperLimit": "100",
        "showValue": "1",
        "numberSuffix": "%",
        "theme": "fusion",
        "showToolTip": "0"
    },
    // Chart Data
    "colorRange": {
        "color": [{
            "minValue": "0",
            "maxValue": "50",
            "code": "#F2726F"
        }, {
            "minValue": "50",
            "maxValue": "75",
            "code": "#FFC533"
        }, {
            "minValue": "75",
            "maxValue": "100",
            "code": "#62B58F"
        }]
    },
    "dials": {
        "dial": [{
            "value": "81"
        }]
    }
}

In the above JSON:

  • Create the chart object to define the elements of the gauge.

  • Create the colorRange array to set the color associated with the specific range of values.

  • Specify minValue and maxValue within the color array under the colorRange array.

  • Specify the hex code of the color within the color array.

  • Create the dials object to represent the customer satisfaction score.

  • Create the dial object under dials object to set the value of the dial in an array.

The chart object and the respective arrays contain a set of key-value pairs known as attributes. These attributes are used to set the functional and cosmetic properties of the gauge.

Now that you have converted the tabular data to JSON format, let's learn how to render the gauge.

Render the gauge

To render the gauge, follow the steps below:

  1. Include react

  2. Include react-fusioncharts

  3. Include the fusioncharts library

  4. Include gauge type.

  5. Include the FusionCharts theme file to apply style to the charts.

  6. Add the gauge and the theme as a dependency to the core.

  7. Store the chart configurations as a JSON object. In this JSON object:

    • Set the gauge type as angulargauge. Each chart type is represented with a unique chart alias. For Angular Gauge, the alias is angulargauge. Find the complete list of gauge types with their respective alias here.

    • Set the width and height (in pixels).

    • Set the dataFormat as json.

    • Embed the json data as the value of the dataSource.

  8. Create the DOM element and pass the react-fusioncharts component directly to the ReactDOM.render() method.

The consolidated code is shown below:

// Step 1 - Including react
import React from 'react';
import ReactDOM from 'react-dom';

// Step 2 - Including the react-fusioncharts component
import ReactFC from 'react-fusioncharts';

// Step 3 - Including the fusioncharts library
import FusionCharts from 'fusioncharts';

// Step 4 - Including the chart type
import Widgets from 'fusioncharts/fusioncharts.widgets';

// Step 5 - Including the theme as fusion
import FusionTheme from 'fusioncharts/themes/fusioncharts.theme.fusion';

// Step 6 - Adding the chart as dependency to the core fusioncharts
ReactFC.fcRoot(FusionCharts, Widgets, FusionTheme);

// Step 7 - Creating the JSON object to store the chart configurations
const chartConfigs = {
    type: 'angulargauge', // The gauge type
    width: '450', // Width of the gauge
    height: '250', // Height of the gauge
    dataFormat: 'json', // Data type
    dataSource: {
    // Chart Configuration
      "chart": {
          "caption": "Nordstorm's Customer Satisfaction Score for 2017",
          "lowerLimit": "0",
          "upperLimit": "100",
          "showValue": "1",
          "numberSuffix": "%",
          "theme": "fusion",
          "showToolTip": "0"
      },
      // Chart Data
      "colorRange": {
          "color": [{
              "minValue": "0",
              "maxValue": "50",
              "code": "#F2726F"
          }, {
              "minValue": "50",
              "maxValue": "75",
              "code": "#FFC533"
          }, {
              "minValue": "75",
              "maxValue": "100",
              "code": "#62B58F"
          }]
      },
      "dials": {
          "dial": [{
              "value": "81"
          }]
      }
  }
};

// Step 8 - Creating the DOM element to pass the react-fusioncharts component 
class App extends React.Component {
  render() {
     return (
     <ReactFC
        {...chartConfigs}/>
     );
  }
}

export default App

<html>
<head>
    <!-- Including react -->
    <script type="text/javascript" src="https://unpkg.com/react@16/umd/react.development.js"></script>
    <!-- Including react-dom -->
    <script type="text/javascript" src="https://unpkg.com/react-dom@16/umd/react-dom.development.js"></script> 
    <!-- Including babel -->
    <script type="text/javascript" src="https://unpkg.com/babel-standalone@6/babel.min.js"></script> 
    <!-- Including the fusioncharts core library -->
    <script type="text/javascript" src="http://cdn.fusioncharts.com/fusioncharts/latest/fusioncharts.js"></script> 
    <!-- Including the fusioncharts library to render charts -->
    <script type="text/javascript" src="http://cdn.fusioncharts.com/fusioncharts/latest/fusioncharts.charts.js"></script> 
    <!-- Including react-fusioncharts component -->
    <script type="text/javascript" src="https://unpkg.com/[email protected]/dist/react-fusioncharts.min.js"></script> 
    <!-- Including the fusion theme -->
    <script type="text/javascript" src="http://cdn.fusioncharts.com/fusioncharts/latest/themes/fusioncharts.theme.fusion.js"></script> 
    <script type="text/jsx">
    ReactFC.fcRoot(FusionCharts);
    const chartConfigs = {
        type: 'angulargauge',
        renderAt: 'chart-container',
        width: '450',
        height: '250',
        dataFormat: 'json',
        dataSource: {
            // Chart Configuration
            "chart": {
                "caption": "Nordstorm's Customer Satisfaction Score for 2017",
                "lowerLimit": "0",
                "upperLimit": "100",
                "showValue": "1",
                "numberSuffix": "%",
                "theme": "fusion",
                "showToolTip": "0"
            },
            // Chart Data
            "colorRange": {
                "color": [{
                    "minValue": "0",
                    "maxValue": "50",
                    "code": "#F2726F"
                }, {
                    "minValue": "50",
                    "maxValue": "75",
                    "code": "#FFC533"
                }, {
                    "minValue": "75",
                    "maxValue": "100",
                    "code": "#62B58F"
                }]
            },
            "dials": {
                "dial": [{
                    "value": "81"
                }]
            }
        }
    };
    </script>
    <script type="text/jsx">
    ReactDOM.render(
        <ReactFC {...chartConfigs} />,
        document.getElementById('chart-container')
    );
    </script>
</head>
<body>
    <div id='chart-container'></div>
</body>
</html>

<html>
<head>
    <!-- Including react -->
    <script type="text/javascript" src="path/to/local/react.development.js"></script>
    <!-- Including react-dom -->
    <script type="text/javascript" src="path/to/local/react-dom.development.js"></script>
    <!-- Including babel -->
    <script type="text/javascript" src="path/to/local/babel.min.js"></script>
    <!-- Including the fusioncharts core library -->
    <script type="text/javascript" src="path/to/local/fusioncharts.js"></script>
    <!-- Including the fusioncharts library to render charts -->
    <script type="text/javascript" src="path/to/local/fusioncharts.widgets.js"></script>
    <!-- Including react-fusioncharts component -->
    <script type="text/javascript" src="path/to/local/react-fusioncharts.min.js"></script>
    <!-- Including the fusion theme -->
    <script type="text/javascript" src="path/to/local/themes/fusioncharts.theme.fusion.js"></script>
    <script type="text/jsx">
    ReactFC.fcRoot(FusionCharts);
    const chartConfigs = {
        type: 'angulargauge',
        renderAt: 'chart-container',
        width: '450',
        height: '250',
        dataFormat: 'json',
        dataSource: {
            // Gauge Configuration
            "chart": {
                "caption": "Countries With Most Oil Reserves [2017-18]",
                "subCaption": "In MMbbl = One Million barrels",
                "xAxisName": "Country",
                "yAxisName": "Reserves (MMbbl)",
                "numberSuffix": "K",
                "theme": "fusion",
            },
            // Chart Data
            "data": [{
                "label": "Venezuela",
                "value": "290"
            }, {
                "label": "Saudi",
                "value": "260"
            }, {
                "label": "Canada",
                "value": "180"
            }, {
                "label": "Iran",
                "value": "140"
            }, {
                "label": "Russia",
                "value": "115"
            }, {
                "label": "UAE",
                "value": "100"
            }, {
                "label": "US",
                "value": "30"
            }, {
                "label": "China",
                "value": "30"
            }]
        }
    };
    </script>
    <script type="text/jsx">
    ReactDOM.render(
        <ReactFC {...chartConfigs} />,
        document.getElementById('chart-container')
    );
    </script>
</head>
<body>
    <div id='chart-container'></div>
</body>
</html>

That's it! Your first gauge using react-fusioncharts is ready.

Problem rendering the chart?

In case there is an error, and you are unable to see the chart, check for the following:

  • If you are getting a JavaScript error on your page, check your browser console for the exact error and fix accordingly. If you're unable to solve it, click here to get in touch with our support team.

  • If the chart does not show up at all, but there are no JavaScript errors, check if the FusionCharts Suite XT JavaScript library has loaded correctly. You can use developer tools within your browser to see if fusioncharts.js was loaded.

  • If you get a Loading Data or Error in loading data message, check whether your JSON data structure is correct, or there are conflicts related to quotation marks in your code.